"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var redux_data_service_1 = require("redux-data-service");
var react_1 = require("@storybook/react");
var InfiniteScroll_1 = require("./InfiniteScroll");
var TestUtils_1 = require("../TestUtils");
var containerStyle = {
    height: 500,
    width: 500,
    border: "solid 1px black",
    backgroundColor: "white !important",
    overflow: "auto",
    display: "block",
};
var Container = function (props) {
    return (React.createElement("div", __assign({ style: containerStyle }, props), props.children));
};
var ContainerModel = function (_a) {
    var model = _a.model, uniformHeights = _a.uniformHeights;
    var style = {
        height: uniformHeights ? 50 : model.id % 100 + 50,
        padding: "25px",
        borderBottom: "solid 1px #999",
    };
    return (React.createElement("div", { style: style },
        React.createElement("p", null,
            "ID: ",
            model.id),
        React.createElement("p", null,
            "Title: ",
            model.fullText)));
};
var Table = function (_a) {
    var children = _a.children, items = _a.items, props = __rest(_a, ["children", "items"]);
    return (React.createElement("table", __assign({ style: containerStyle }, props),
        React.createElement("tbody", null, children)));
};
var TableRow = function (_a) {
    var model = _a.model, props = __rest(_a, ["model"]);
    var style = {
        height: model.id % 100 + 50,
        padding: "25px",
        borderBottom: "solid 1px #999",
    };
    return (React.createElement("tr", __assign({ style: style }, props),
        React.createElement("td", null,
            "ID: ",
            model.id),
        React.createElement("td", null,
            "Title: ",
            model.fullText)));
};
var TableContentPlaceHolder = function (_a) {
    var height = _a.height;
    var style = {
        height: height,
    };
    return (React.createElement("tr", { style: style }));
};
react_1.storiesOf("InfiniteScroll", module)
    .addDecorator(function (story) {
    redux_data_service_1.initializeTestServices(redux_data_service_1.fakeModelModule);
    TestUtils_1.seedServiceListWithPagingOptions("fakeModel", 25, 50);
    return story();
})
    .add("Infinite Scrolling Uniform Heights", function () { return (React.createElement(InfiniteScroll_1.InfiniteScroll, { containerComponent: Container, disableVirtualScrolling: true, modelComponent: ContainerModel, modelComponentProps: { uniformHeights: true }, modelName: "fakeModel", query: { page: 1 } })); })
    .add("Infinite Scrolling Variable Heights", function () { return (React.createElement(InfiniteScroll_1.InfiniteScroll, { containerComponent: Container, disableVirtualScrolling: true, modelComponent: ContainerModel, modelName: "fakeModel", query: { page: 1 } })); })
    .add("Virtual Scrolling Uniform Heights", function () { return (React.createElement(InfiniteScroll_1.InfiniteScroll, { containerComponent: Container, modelComponent: ContainerModel, modelComponentProps: { uniformHeights: true }, modelName: "fakeModel", query: { page: 1 } })); })
    .add("Virtual Scrolling Variable Heights", function () { return (React.createElement(InfiniteScroll_1.InfiniteScroll, { containerComponent: Container, modelComponent: ContainerModel, modelName: "fakeModel", query: { page: 1 } })); })
    .add("Virtual Scrolling Table", function () { return (React.createElement(InfiniteScroll_1.InfiniteScroll, { containerComponent: Table, modelComponent: TableRow, contentPlaceHolderComponent: TableContentPlaceHolder, modelName: "fakeModel", query: { page: 1 } })); });
