import * as React from "react";
import { IModel, Omit } from "redux-data-service";
export interface IFieldInputProps {
    name: string;
    onChange: <T>(event: React.ChangeEvent<T> | any) => void;
    onBlur?: <T>(event?: React.FocusEvent<T>) => void;
    onFocus?: <T>(event?: React.FocusEvent<T>) => void;
    onFieldError?: (error: string) => void;
    value?: any;
}
export interface IModelFieldProps<T = any> extends Omit<Partial<IFieldInputProps>, "value"> {
    readOnlyFieldName?: string;
    validateField?: (model: IModel<any>, name: string) => void;
    defaultValue?: any;
    fieldComponent?: React.ComponentType<IFieldInputProps & any>;
    component?: React.ComponentType<IFieldInputProps & any>;
    componentProps?: ((props: IFieldInputProps & Partial<T>) => Partial<T>) | Partial<T>;
    readOnlyComponent?: React.ComponentType<IFieldInputProps & any>;
    readOnlyComponentProps?: ((props: IFieldInputProps & Partial<T>) => Partial<T>) | Partial<T>;
    [otherProp: string]: any;
}
export interface IFieldContext {
    field: {
        onFieldError: (errorMessage: string) => void;
    };
}
export declare const defaultValidateField: (model: IModel<any>, name: string) => {
    [x: string]: any;
};
export declare const Field: ({ component: Component, componentProps, readOnly, readOnlyComponent: ReadOnlyComponent, readOnlyComponentProps, ...props }: {
    [x: string]: any;
    component: any;
    componentProps: any;
    readOnly: any;
    readOnlyComponent: any;
    readOnlyComponentProps: any;
}) => JSX.Element;
export declare const ModelField: React.ComponentClass<IModelFieldProps<any>>;
