"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var PropTypes = require("prop-types");
var lodash_1 = require("lodash");
var recompose_1 = require("recompose");
var Helpers_1 = require("../Helpers");
exports.defaultValidateField = function (model, name) { return model.validateField(name); };
exports.Field = function (_a) {
    var Component = _a.component, componentProps = _a.componentProps, readOnly = _a.readOnly, ReadOnlyComponent = _a.readOnlyComponent, readOnlyComponentProps = _a.readOnlyComponentProps, props = __rest(_a, ["component", "componentProps", "readOnly", "readOnlyComponent", "readOnlyComponentProps"]);
    return (readOnly
        ? React.createElement(ReadOnlyComponent, __assign({}, props, readOnlyComponentProps))
        : React.createElement(Component, __assign({}, props, componentProps)));
};
exports.ModelField = recompose_1.compose(recompose_1.setDisplayName("ModelField"), recompose_1.defaultProps({
    validateField: exports.defaultValidateField,
    fieldComponent: exports.Field,
    readOnlyComponent: function (_a) {
        var value = _a.value;
        return React.createElement("span", null, value);
    },
    component: function (props) { return React.createElement("input", __assign({}, props)); }
}), recompose_1.getContext({
    model: PropTypes.object,
    readOnly: PropTypes.bool
}), recompose_1.withPropsOnChange(["defaultValue", "model", "name", "readOnly"], function (_a) {
    var model = _a.model, name = _a.name, defaultValue = _a.defaultValue, readOnly = _a.readOnly;
    if (!readOnly && model != null && defaultValue != null && lodash_1.isEmpty(lodash_1.get(model, name))) {
        lodash_1.set(model, name, defaultValue);
    }
}), recompose_1.withStateHandlers({ active: false, internalErrorMessage: undefined }, {
    onChange: function (state, _a) {
        var model = _a.model, name = _a.name, onChange = _a.onChange, validateField = _a.validateField;
        return function (event) {
            var value = (typeof event === "object" && "target" in event)
                ? (event.target.value == null && event.target.checked) || event.target.value || null
                : event;
            lodash_1.set(model, name, value);
            if (onChange) {
                onChange(event);
            }
            validateField(model, name);
            return state;
        };
    },
    onFieldError: function () { return function (errorMessage) { return ({
        internalErrorMessage: errorMessage,
    }); }; },
    onBlur: function (state, _a) {
        var onBlur = _a.onBlur, model = _a.model, name = _a.name, validateField = _a.validateField;
        return function (event) {
            if (onBlur) {
                onBlur(event);
            }
            validateField(model, name);
            return { active: false };
        };
    },
    onFocus: function (state, _a) {
        var onFocus = _a.onFocus;
        return function (event) {
            if (onFocus) {
                onFocus(event);
            }
            return { active: true };
        };
    },
}), recompose_1.withContext({ field: PropTypes.object }, function (_a) {
    var active = _a.active, onFieldError = _a.onFieldError, model = _a.model, name = _a.name, internalErrorMessage = _a.internalErrorMessage;
    var fieldErrors = model.getFieldError(name);
    var errorMessage = !lodash_1.isEmpty(fieldErrors)
        ? fieldErrors
        : internalErrorMessage;
    var isFieldDirty = model.isFieldDirty(name);
    return {
        field: {
            active: active,
            errorMessage: errorMessage,
            isFieldDirty: isFieldDirty,
            onFieldError: onFieldError,
        }
    };
}), recompose_1.withPropsOnChange(["model", "readOnlyFieldName", "name", "readOnly"], function (_a) {
    var model = _a.model, readOnlyFieldName = _a.readOnlyFieldName, name = _a.name, readOnly = _a.readOnly;
    return ({
        value: readOnly && readOnlyFieldName
            ? lodash_1.get(model, readOnlyFieldName)
            : lodash_1.get(model, name)
    });
}), Helpers_1.omitProps(["model", "active", "internalErrorMessage", "onFieldError", "defaultValue", "validateField", "readOnlyFieldName"]))(function (_a) {
    var FieldComponent = _a.fieldComponent, props = __rest(_a, ["fieldComponent"]);
    return React.createElement(FieldComponent, __assign({}, props));
});
